//Weather - Weather forecast on the Main Menu
//(c) pibos
//http://wdtvforum.com/main/index.php?topic=5577
//Modified for 0.4.2.2+ integrated WDTVExt by DJArty
/*
# meta-name="Weather"
# meta-desc="Weather Forecast Plugin"
# meta-author="pibos"
# meta-date="2010-21-09"
# meta-version="0.2"
# meta-type="wdtvext"
# meta-url="http://forum.wdlxtv.com/viewtopic.php?f=48&t=1520"
# meta-filename="Weather.plugin.js"
*/


traceln("Start loading weather plugin")
// all traces both trace and traceln will output in /boot/wdtvext.log

function WeatherPlugin(path) {

    // no need to check for now, proper variable is supplied
    //this.rootPath = scriptPath ? scriptPath : "/boot/plugins/Weather/";
    this.rootPath = path;
//   this.location = "EUR|RO|RO010|BUCHAREST|";  <-- example
//   CHANGE Location !!! 
    this.location = "EUR|UA|UP006|KHARKIV";
    this.urlBase = "http://vwidget.accuweather.com/widget/vista1/weather_data_v2.asp?location={location}&metric=1";
    this.misto = "" ;

}

// chain WeatherPlugin with proper inheritance - classical in javascript
WeatherPlugin.prototype = new Plugin();

WeatherPlugin.prototype.constructor = WeatherPlugin;

WeatherPlugin.prototype.doBuildMenus = function() {
    var topMenuWeather = new Menu("Weather", "$$Weather", this.rootPath + "images/weather_n.png", this.rootPath + "images/weather_f.png", true);

    // create 5 menu items and keep reference
    
    // add all the items, but invisible, will make them visible as data is available
    topMenuWeather.addChild(new Menu("Day1", "", "", "", false));
    topMenuWeather.addChild(new Menu("Day2", "", "", "", false));
    topMenuWeather.addChild(new Menu("Day3", "", "", "", false));
    topMenuWeather.addChild(new Menu("Day4", "", "", "", false));
    topMenuWeather.addChild(new Menu("Day5", "", "", "", false));

    // add refresh menu 
    topMenuWeather.addChild(new Menu("Refresh", "$$Update forecast", this.rootPath + "images/refresh_n.png", this.rootPath + "images/refresh_f.png", true));
    // add earth map menu last
    topMenuWeather.addChild(new Menu("Map", "$$Earth map", this.rootPath + "images/earth_64.png", this.rootPath + "images/earth_128.png", true));
 

    // close the loop
    topMenuWeather.lastChild.next = topMenuWeather.firstChild;
    topMenuWeather.firstChild.prev = topMenuWeather.lastChild;

    Menu.Top.addChild(topMenuWeather);

    
     // we could have added a handler to our top level Weather menu, but dmaosd decides then that it will not show any chidrens under this menu ... :(
    //  // refresh data on menu select
    // or we could add it on any child
    Menu.Top.Weather.Refresh.handler = function(){
      WeatherPlugin.instance.refreshForecast();
    }

    Menu.Top.Weather.Map.handler = function(){
      WeatherPlugin.instance.refreshMap();
    }

    // populate initial data
    this.refreshForecast();
}


WeatherPlugin.prototype.onPageCreated =  function(page){
 if (page.markupFileName == "villa_home.xml") {
    addExtraContentFile(page, this.rootPath+"weather.xml");
 }
}

//WeatherPlugin.prototype.onPageEnter =  function(page){
// traceln("WeatherPlugin.onPageEnter on page " + page.markupFileName);
//}

//WeatherPlugin.prototype.onPageKey =  function(page, key){
//  traceln("WeatherPlugin.onPageKey on page " + page.markupFileName + "key = " + key);
//}

WeatherPlugin.prototype.onPageLeave =  function(page){
//  traceln("WeatherPlugin.onPageLeave on page " + page.markupFileName );
  Page.Top.setParam("weather_bg", "");
  Page.Top.setParam("misto", "");
//  Page.Top.setParam("selectedMenu", "");
  Page.Top.setParam("weather_bg_visible",0);
}

//WeatherPlugin.prototype.onPageTimer =  function(page){
  //commented out as it produces a lot of noise in the log output
  //traceln("WeatherPlugin.onPageTimer on page " + page.markupFileName );
//}


WeatherPlugin.prototype.onMenuSelect =  function(menuItem){
  if(menuItem.forecast){
      Page.Top.setParam("misto", this.misto);
//      Page.Top.setParam("selectedMenu", menuItem.title);
  }
}

WeatherPlugin.prototype.onMenuDeselect =  function(menuItem){
  Page.Top.setParam("weather_bg", "");
  Page.Top.setParam("misto", "");
//  Page.Top.setParam("selectedMenu", "");
  Page.Top.setParam("weather_bg_visible",0);
}


// functions declared at proptotype level (WeatherPlugin.prototype.refreshForecast) will be inherited by any instance of the pseudo class WeatherPlugin

WeatherPlugin.prototype.refreshForecast = function(){
    // compose the final url from template and location 
    // location is a property of your plugin configured in constructor, WeatherPlugin function
    var url = this.urlBase.format(this);
    traceln("Wather plugin loading data from " + url);

    //javascript helper class to measure duration of various operations, defined in common.js
    var t = new Timer(true);
    
    //native class used to access the NET
    var curl = new CurlEasy(url);
    
    if (curl.perform()) {
        t.mark("fetch from web completed at {span}ms");

        var content = curl.responseText;
        // content.toXML is an helper function defined in common.js as an extension to String class
        var doc = content.toXML();
        // doc is now pointing to an XML object see mozilla spidermonkey and E4X (Ecmascript for xml) specs
        this.misto = doc.local.@city + " " + doc.local.@time.toString();
        for (var idx in doc.forecast.day) {
            // loop for day xml nodes in forecast
            
            day = doc.forecast.day[idx]
	
            var icon = this.rootPath + "images/" + day.daytime.wxf.@icon + ".png";
            var number = day.@number.toString();
            var title = "$$" + day.@wday.toString();
            var temp = day.daytime.wxf.@htmp.toString() + "°C/" + day.daytime.wxf.@ltmp.toString()+"°C ";
   
              var menu = Menu.Top.Weather["Day" + number];
              // access child Day menus we defined in Plugin's build_menus function
              // all the tree can be accesses starting from Menu.Top root Menu class instance
              // Menu class properties: 
              //  firstChild, 
              //  parent, 
              //  next, 
              //  prev, 
              //  childCount
              //  name - internal used by dmaosd,
              //   title - localized and displayed 
              //  image - normal image
              //  focusedImage,
              //  visible
              // handler - javascript function called when the menu is selected from remote; 
              //          you can intercept custom or system menus execution like this
              //          Menu.Top.Settings.firstChild.oldHandler = Menu.Top.Settings.firstChild.handler
              //          Menu.Top.Settings.firstChild.handler = function(){
              //            if(IAmInTheMoodCondition)
              //                  this.oldHandler() // trigger the old behaviour 
              //          ....
              //          ....
              //          ....
              //          ....
              //          }
               

              if(menu){
                menu.title = title + " " + temp + day.daytime.txtshort.text().toString(); 
                menu.image = icon; 
                menu.focusedImage = icon; 
                menu.visible = true;
                // keep track of forecast node to dispaly extra info on page when this node is selected
                menu.forecast = day;
              }

        }
	

        Page.redraw(true); // force redraw

        t.mark("loaded content completed at {span}ms");
        

    }
}

WeatherPlugin.prototype.refreshMap = function(){
	Page.Top.setParam("weather_bg", "http://static.die.net/earth/mercator/1600.jpg");
        Page.Top.setParam("weather_bg_visible",1);
        Page.redraw(true); // force redraw

}


// create our plugin with baseParg pointing to current script path
// global variables scriptName, scriptLocation and scriptFullPath are available, no need to do the following
WeatherPlugin.instance = new WeatherPlugin(scriptPath);

// register our plugin with Ext
Plugin.registerPlugin(WeatherPlugin.instance);

traceln("End loading weather plugin");


//  we are done here ... 
//  don't forget to let me know if you are missing something, beside being notified when a menu selection changes, that is in the workings
//
//  p.
